## xtensor-python 0.10.0

=== CMakeLists.txt ===
############################################################################
# Copyright (c) 2016, Johan Mabille and Sylvain Corlay                     #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

cmake_minimum_required(VERSION 3.1)
project(xtensor-python)

set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
set(XTENSOR_PYTHON_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)

# Versionning
# ===========

set(XTENSOR_PYTHON_CONFIG_FILE
    "${XTENSOR_PYTHON_INCLUDE_DIR}/xtensor-python/xtensor_python_config.hpp")
file(STRINGS ${XTENSOR_PYTHON_CONFIG_FILE} xtensor_python_version_defines
    REGEX "#define XTENSOR_PYTHON_VERSION_(MAJOR|MINOR|PATCH)")
foreach(ver ${xtensor_python_version_defines})
    if(ver MATCHES "#define XTENSOR_PYTHON_VERSION_(MAJOR|MINOR|PATCH) +([^ ]+)$")
        set(XTENSOR_PYTHON_VERSION_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
    endif()
endforeach()
set(${PROJECT_NAME}_VERSION 
    ${XTENSOR_PYTHON_VERSION_MAJOR}.${XTENSOR_PYTHON_VERSION_MINOR}.${XTENSOR_PYTHON_VERSION_PATCH})
message(STATUS "xtensor-python v${${PROJECT_NAME}_VERSION}")

# Build
# =====

set(XTENSOR_PYTHON_HEADERS
    ${XTENSOR_PYTHON_INCLUDE_DIR}/xtensor-python/pyarray.hpp
    ${XTENSOR_PYTHON_INCLUDE_DIR}/xtensor-python/pybuffer_adaptor.hpp
    ${XTENSOR_PYTHON_INCLUDE_DIR}/xtensor-python/pycontainer.hpp
    ${XTENSOR_PYTHON_INCLUDE_DIR}/xtensor-python/pytensor.hpp
    ${XTENSOR_PYTHON_INCLUDE_DIR}/xtensor-python/pyvectorize.hpp
    ${XTENSOR_PYTHON_INCLUDE_DIR}/xtensor-python/xtensor_python_config.hpp
)

OPTION(BUILD_TESTS "xtensor test suite" OFF)
OPTION(DOWNLOAD_GTEST "build gtest from downloaded sources" OFF)

if(DOWNLOAD_GTEST OR GTEST_SRC_DIR)
    set(BUILD_TESTS ON)
endif()

if(BUILD_TESTS)
    include_directories(${XTENSOR_PYTHON_INCLUDE_DIR})
    find_package(xtensor REQUIRED)
    include_directories(${xtensor_INCLUDE_DIR})
    find_package(NumPy REQUIRED)
    include_directories(${NUMPY_INCLUDE_DIRS})

    find_package(pybind11 REQUIRED)
    include_directories(${pybind11_INCLUDE_DIRS})

    if(MSVC)
        set(PYTHON_MODULE_EXTENSION ".pyd")
    else()
        set(PYTHON_MODULE_EXTENSION ".so")
    endif()

    add_subdirectory(test)
    add_subdirectory(benchmark)
endif()

# Installation
# ============

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

install(FILES ${XTENSOR_PYTHON_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/xtensor-python)

# GNUInstallDirs "DATADIR" wrong here; CMake search path wants "share".
set(XTENSOR_PYTHON_CMAKECONFIG_INSTALL_DIR "share/cmake/${PROJECT_NAME}" CACHE STRING "install path for xtensor-pythonConfig.cmake")

configure_package_config_file(${PROJECT_NAME}Config.cmake.in
                              "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
                              INSTALL_DESTINATION ${XTENSOR_PYTHON_CMAKECONFIG_INSTALL_DIR})

# xtensor-python is header-only and does not depend on the architecture.
# Remove CMAKE_SIZEOF_VOID_P from xtensor-pythonConfigVersion.cmake so that an xtensor-pythonConfig.cmake
# generated for a 64 bit target can be used for 32 bit targets and vice versa.
set(_XTENSOR_CMAKE_SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P})
unset(CMAKE_SIZEOF_VOID_P)
write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
                                 VERSION ${${PROJECT_NAME}_VERSION}
                                 COMPATIBILITY AnyNewerVersion)
set(CMAKE_SIZEOF_VOID_P ${_XTENSOR_CMAKE_SIZEOF_VOID_P})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
        DESTINATION ${XTENSOR_PYTHON_CMAKECONFIG_INSTALL_DIR})

=== test/CMakeLists.txt ===
############################################################################
# Copyright (c) 2016, Johan Mabille and Sylvain Corlay                     #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

cmake_minimum_required(VERSION 3.1)

if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    project(xtensor-python-test)

    find_package(pybind11 REQUIRED)
    set(PYBIND11_INCLUDE_DIR ${pybind11_INCLUDE_DIRS})

    find_package(xtensor REQUIRED CONFIG)
    set(XTENSOR_INCLUDE_DIR ${xtensor_INCLUDE_DIR})

    find_package(xtensor-python REQUIRED CONFIG)
    set(XTENSOR_PYTHON_INCLUDE_DIR ${xtensor-python_INCLUDE_DIR})
endif ()

message(STATUS "Forcing tests build type to Release")
set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)

include(CheckCXXCompilerFlag)

string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Intel")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native -Wunused-parameter -Wextra -Wreorder -Wconversion")
    CHECK_CXX_COMPILER_FLAG("-std=c++14" HAS_CPP14_FLAG)

    if (HAS_CPP14_FLAG)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
    else()
        message(FATAL_ERROR "Unsupported compiler -- xtensor requires C++14 support!")
    endif()
endif()

if(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc /MP /bigobj")
    set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
    foreach(flag_var
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
        string(REPLACE "/MD" "-MT" ${flag_var} "${${flag_var}}")
    endforeach()
endif()

if (DOWNLOAD_GTEST OR GTEST_SRC_DIR)
    if(DOWNLOAD_GTEST)
        # Download and unpack googletest at configure time
        configure_file(downloadGTest.cmake.in googletest-download/CMakeLists.txt)
    else()
        # Copy local source of googletest at configure time
        configure_file(copyGTest.cmake.in googletest-download/CMakeLists.txt)
    endif()
    execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
                    RESULT_VARIABLE result
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
    if(result)
        message(FATAL_ERROR "CMake step for googletest failed: ${result}")
    endif()
    execute_process(COMMAND ${CMAKE_COMMAND} --build .
                    RESULT_VARIABLE result
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
    if(result)
        message(FATAL_ERROR "Build step for googletest failed: ${result}")
    endif()

    # Add googletest directly to our build. This defines
    # the gtest and gtest_main targets.
    add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/googletest-src
                     ${CMAKE_CURRENT_BINARY_DIR}/googletest-build)

    set(GTEST_INCLUDE_DIRS "${gtest_SOURCE_DIR}/include")
    set(GTEST_BOTH_LIBRARIES gtest_main gtest)
else()
    find_package(GTest REQUIRED)
endif()

find_package(Threads)

include_directories(${XTENSOR_INCLUDE_DIR})
include_directories(${XTENSOR_PYTHON_INCLUDE_DIR})
include_directories(${GTEST_INCLUDE_DIRS})
include_directories(${PYBIND11_INCLUDE_DIR})

set(XTENSOR_PYTHON_TESTS
    main.cpp
    test_pyarray.cpp
    test_pytensor.cpp
    test_pyvectorize.cpp
)

set(XTENSOR_PYTHON_TARGET test_xtensor_python)
add_executable(${XTENSOR_PYTHON_TARGET} ${XTENSOR_PYTHON_TESTS} ${XTENSOR_PYTHON_HEADERS} ${XTENSOR_HEADERS})
target_link_libraries(${XTENSOR_PYTHON_TARGET} ${GTEST_BOTH_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${PYTHON_LIBRARIES})

if(DOWNLOAD_GTEST OR GTEST_SRC_DIR)
    add_dependencies(${XTENSOR_PYTHON_TARGET} gtest_main)
endif()

add_custom_target(xtest COMMAND ./test_xtensor_python DEPENDS ${XTENSOR_PYTHON_TARGET})

## xtensor-python 0.11.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -50,7 +50,7 @@
 if(BUILD_TESTS)
     include_directories(${XTENSOR_PYTHON_INCLUDE_DIR})
     find_package(xtensor REQUIRED)
-    include_directories(${xtensor_INCLUDE_DIR})
+    include_directories(${xtensor_INCLUDE_DIRS})
     find_package(NumPy REQUIRED)
     include_directories(${NUMPY_INCLUDE_DIRS})

=== debian/changelog ===
xtensor-python (0.11.0-1) unstable; urgency=medium

  * Fixup the watch regex
  * New upstream version 0.11.0
  * Rebase the patch queue
  * Build depends on xtensor >= 0.10.0

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 09 May 2017 19:32:54 +0100

xtensor-python (0.10.0-1) unstable; urgency=medium

  * New upstream version 0.10.0
  * Refresh the patch queue
  * Build depends on xtensor >= 0.9.0

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 18 Apr 2017 21:47:28 +0100

xtensor-python (0.9.4-1) unstable; urgency=medium

  * New upstream version 0.9.4
  * Refresh the patch queue
  * Use ANY_VERSION substvar in watch file

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 15 Apr 2017 10:13:52 +0100

xtensor-python (0.9.2-2) unstable; urgency=medium

  * Add missing copyright information.
    Thanks to Chris Lamb (Closes: #860166)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 12 Apr 2017 14:55:40 +0100

xtensor-python (0.9.2-1) unstable; urgency=low

  * Initial release. (Closes: #858068)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Mon, 10 Apr 2017 19:05:41 +0100

=== debian/control ===
Source: xtensor-python
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake (>= 3.1),
               debhelper (>= 10),
               dpkg-dev (>= 1.17.14),
               googletest <!nocheck>,
               pybind11-dev (>= 2.0.0) <!nocheck>,
               python3-breathe <!nodoc>,
               python3-dev <!nocheck>,
               python3-numpy <!nocheck>,
               python3-sphinx <!nodoc>,
               python3-sphinx-rtd-theme <!nodoc>,
               sphinx-common,
               xtensor-dev (>= 0.10.0) <!nocheck>
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/xtensor-python.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/xtensor-python.git
Homepage: http://quantstack.net/xtensor

Package: xtensor-python-dev
Architecture: all
Depends: ${misc:Depends},
         pybind11-dev (>= 2.0.0),
         xtensor-dev (>= 0.8.1)
Suggests: xtensor-python-doc <!nodoc>
Description: Python bindings for the xtensor library
 xtensor is a C++ library for multi-dimensional arrays enabling numpy-style
 broadcasting and lazy computing.
 .
 xtensor-python enables inplace use of numpy arrays in C++ with all the
 benefits from xtensor:
 .
   - C++ universal function and broadcasting
   - STL - compliant APIs.
   - A broad coverage of numpy APIs (see the numpy to xtensor cheat sheet).
 .
 The Python bindings for xtensor are based on the pybind11 C++ library, which
 enables seemless interoperability between C++ and Python.
 .
 This package provides the header-only library.

Package: xtensor-python-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Description: documentation for xtensor-python
 xtensor is a C++ library for multi-dimensional arrays enabling numpy-style
 broadcasting and lazy computing.
 .
 xtensor-python enables inplace use of numpy arrays in C++ with all the
 benefits from xtensor:
 .
   - C++ universal function and broadcasting
   - STL - compliant APIs.
   - A broad coverage of numpy APIs (see the numpy to xtensor cheat sheet).
 .
 The Python bindings for xtensor are based on the pybind11 C++ library, which
 enables seemless interoperability between C++ and Python.
 .
 This package provides the documentation.
Build-Profiles: <!nodoc>

## xtensor-python 0.12.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -33,8 +33,8 @@
 
 set(XTENSOR_PYTHON_HEADERS
     ${XTENSOR_PYTHON_INCLUDE_DIR}/xtensor-python/pyarray.hpp
-    ${XTENSOR_PYTHON_INCLUDE_DIR}/xtensor-python/pybuffer_adaptor.hpp
     ${XTENSOR_PYTHON_INCLUDE_DIR}/xtensor-python/pycontainer.hpp
+    ${XTENSOR_PYTHON_INCLUDE_DIR}/xtensor-python/pystrides_adaptor.hpp
     ${XTENSOR_PYTHON_INCLUDE_DIR}/xtensor-python/pytensor.hpp
     ${XTENSOR_PYTHON_INCLUDE_DIR}/xtensor-python/pyvectorize.hpp
     ${XTENSOR_PYTHON_INCLUDE_DIR}/xtensor-python/xtensor_python_config.hpp

=== debian/changelog ===
xtensor-python (0.12.1-1ubuntu1) artful; urgency=medium

  * Make the autopkgtests pass with multiple supported Python 3 versions.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Mon, 03 Jul 2017 16:39:20 +0300

xtensor-python (0.12.1-1) unstable; urgency=medium

  * New upstream version 0.12.1
  * Rebase the patch queue
  * Depends on xtensor >= 0.10.2
  * Mark xtensor-python-dev Multi-Arch: foreign
  * Do not build with -march=native
    - New patch No-march-native.patch

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 19 May 2017 18:24:52 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: xtensor-python
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
 Section: libs
 Priority: optional
@@ -14,7 +15,7 @@
                python3-sphinx <!nodoc>,
                python3-sphinx-rtd-theme <!nodoc>,
                sphinx-common,
-               xtensor-dev (>= 0.10.0) <!nocheck>
+               xtensor-dev (>= 0.10.2) <!nocheck>
 Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/xtensor-python.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/xtensor-python.git
@@ -22,9 +23,10 @@
 
 Package: xtensor-python-dev
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends},
          pybind11-dev (>= 2.0.0),
-         xtensor-dev (>= 0.8.1)
+         xtensor-dev (>= 0.10.2)
 Suggests: xtensor-python-doc <!nodoc>
 Description: Python bindings for the xtensor library
  xtensor is a C++ library for multi-dimensional arrays enabling numpy-style

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

BUILD_OPTIONS = -DXTENSOR_PYTHON_CMAKECONFIG_INSTALL_DIR="lib/cmake/xtensor-python"

ifeq (,$(findstring nocheck,$(DEB_BUILD_PROFILES)))
BUILD_OPTIONS += -DBUILD_TESTS=ON \
		 -DGTEST_SRC_DIR="/usr/src/googletest" \
		 -DPYTHON_EXECUTABLE="/usr/bin/python3"
else
BUILD_OPTIONS += -DBUILD_TESTS=OFF
endif

%:
	dh $@ --with sphinxdoc

override_dh_auto_clean:
	dh_auto_clean
ifeq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
	$(MAKE) -C docs clean
endif

override_dh_auto_configure:
	dh_auto_configure -- $(BUILD_OPTIONS)

override_dh_auto_build:
	dh_auto_build
ifeq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
	$(MAKE) -C docs html
endif

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_PROFILES)))
	dh_auto_test -- xtest
endif

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

## xtensor-python 0.12.2

=== debian/changelog ===
xtensor-python (0.12.2-1) unstable; urgency=medium

  * New upstream version 0.12.2
  * Refresh the patch queue
  * Bump standards version to 4.0.1, no changes required
  * Add missing get-orig-source target

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 10 Aug 2017 17:36:17 +0100

xtensor-python (0.12.1-2) unstable; urgency=medium

  * Fix autopkgtest failure with multiple Py3 versions.
    Thanks to Dmitry Shachnev (Closes: #867026)
  * Bump standards version to 4.0.0, no changes required

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sun, 09 Jul 2017 22:54:00 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: xtensor-python
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
 Section: libs
 Priority: optional
@@ -16,7 +15,7 @@
                python3-sphinx-rtd-theme <!nodoc>,
                sphinx-common,
                xtensor-dev (>= 0.10.2) <!nocheck>
-Standards-Version: 3.9.8
+Standards-Version: 4.0.1
 Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/xtensor-python.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/xtensor-python.git
 Homepage: http://quantstack.net/xtensor

=== debian/rules ===
--- 
+++ 
@@ -38,3 +38,6 @@
 
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/tmp
+
+get-orig-source:
+	uscan --download-current-version --force-download --no-symlink

## xtensor-python 0.12.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -76,8 +76,8 @@
 install(FILES ${XTENSOR_PYTHON_HEADERS}
         DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/xtensor-python)
 
-# GNUInstallDirs "DATADIR" wrong here; CMake search path wants "share".
-set(XTENSOR_PYTHON_CMAKECONFIG_INSTALL_DIR "share/cmake/${PROJECT_NAME}" CACHE STRING "install path for xtensor-pythonConfig.cmake")
+set(XTENSOR_PYTHON_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE
+    STRING "install path for xtensor-pythonConfig.cmake")
 
 configure_package_config_file(${PROJECT_NAME}Config.cmake.in
                               "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"

=== benchmark/CMakeLists.txt ===
############################################################################
# Copyright (c) 2016, Johan Mabille and Sylvain Corlay                     #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

message(STATUS "Forcing tests build type to Release")
set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)

include(CheckCXXCompilerFlag)

string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Intel")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native -Wunused-parameter -Wextra -Wreorder -Wconversion")
    CHECK_CXX_COMPILER_FLAG("-std=c++14" HAS_CPP14_FLAG)

    if (HAS_CPP14_FLAG)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
    else()
        message(FATAL_ERROR "Unsupported compiler -- xtensor requires C++14 support!")
    endif()

    # Enable link time optimization and set the default symbol
    # visibility to hidden (very important to obtain small binaries)
    if (NOT ${U_CMAKE_BUILD_TYPE} MATCHES DEBUG)
        # Default symbol visibility
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")

        # Check for Link Time Optimization support
        # (GCC/Clang)
        CHECK_CXX_COMPILER_FLAG("-flto" HAS_LTO_FLAG)
        if (HAS_LTO_FLAG)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto")
        endif()

        # Intel equivalent to LTO is called IPO
        if (CMAKE_CXX_COMPILER_ID MATCHES "Intel")
            CHECK_CXX_COMPILER_FLAG("-ipo" HAS_IPO_FLAG)
            if (HAS_IPO_FLAG)
                set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ipo")
            endif()
        endif()
    endif()
endif()

if(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc /MP /bigobj")
    set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
    foreach(flag_var
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
        string(REPLACE "/MD" "-MT" ${flag_var} "${${flag_var}}")
    endforeach()
endif()

set(XTENSOR_PYTHON_BENCHMARK
    main.cpp
)

set(XTENSOR_PYTHON_BENCHMARK_TARGET benchmark_xtensor_python)
add_library(${XTENSOR_PYTHON_BENCHMARK_TARGET} MODULE EXCLUDE_FROM_ALL
            ${XTENSOR_PYTHON_BENCHMARK} ${XTENSOR_PYTHON_HEADERS})

set_target_properties(${XTENSOR_PYTHON_BENCHMARK_TARGET} PROPERTIES PREFIX "")
set_target_properties(${XTENSOR_PYTHON_BENCHMARK_TARGET} PROPERTIES SUFFIX "${PYTHON_MODULE_EXTENSION}")

if (APPLE)
    target_link_libraries(${XTENSOR_PYTHON_BENCHMARK_TARGET} PRIVATE "-undefined dynamic_lookup")
elseif (MSVC)
    target_link_libraries(${XTENSOR_PYTHON_BENCHMARK_TARGET} ${PYTHON_LIBRARIES})
else ()
    target_link_libraries(${XTENSOR_PYTHON_BENCHMARK_TARGET} "-shared")
endif()

configure_file(benchmark_pyarray.py benchmark_pyarray.py COPYONLY)
configure_file(benchmark_pytensor.py benchmark_pytensor.py COPYONLY)
configure_file(benchmark_pybind_array.py benchmark_pybind_array.py COPYONLY)
configure_file(benchmark_pyvectorize.py benchmark_pyvectorize.py COPYONLY)
configure_file(benchmark_pybind_vectorize.py benchmark_pybind_vectorize.py COPYONLY)

add_custom_target(xbenchmark DEPENDS ${XTENSOR_PYTHON_BENCHMARK_TARGET})

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -15,10 +15,10 @@
     set(PYBIND11_INCLUDE_DIR ${pybind11_INCLUDE_DIRS})
 
     find_package(xtensor REQUIRED CONFIG)
-    set(XTENSOR_INCLUDE_DIR ${xtensor_INCLUDE_DIR})
+    set(XTENSOR_INCLUDE_DIR ${xtensor_INCLUDE_DIRS})
 
     find_package(xtensor-python REQUIRED CONFIG)
-    set(XTENSOR_PYTHON_INCLUDE_DIR ${xtensor-python_INCLUDE_DIR})
+    set(XTENSOR_PYTHON_INCLUDE_DIR ${xtensor-python_INCLUDE_DIRS})
 endif ()
 
 message(STATUS "Forcing tests build type to Release")

=== debian/changelog ===
xtensor-python (0.12.4-1) unstable; urgency=medium

  * New upstream version 0.12.4 (Closes: #871927)
  * Bump minimum xtensor version to 0.10.9
  * Drop superfluous CMake options
  * Mark xtensor-python-dev section libdevel
  * Mark xtensor-python-doc multiarch foreign

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Mon, 14 Aug 2017 00:59:00 +0100

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                python3-sphinx <!nodoc>,
                python3-sphinx-rtd-theme <!nodoc>,
                sphinx-common,
-               xtensor-dev (>= 0.10.2) <!nocheck>
+               xtensor-dev (>= 0.10.9) <!nocheck>
 Standards-Version: 4.0.1
 Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/xtensor-python.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/xtensor-python.git
@@ -23,9 +23,10 @@
 Package: xtensor-python-dev
 Architecture: all
 Multi-Arch: foreign
+Section: libdevel
 Depends: ${misc:Depends},
          pybind11-dev (>= 2.0.0),
-         xtensor-dev (>= 0.10.2)
+         xtensor-dev (>= 0.10.9)
 Suggests: xtensor-python-doc <!nodoc>
 Description: Python bindings for the xtensor library
  xtensor is a C++ library for multi-dimensional arrays enabling numpy-style
@@ -45,6 +46,7 @@
 
 Package: xtensor-python-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends},
          ${sphinxdoc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE = 1
 
-BUILD_OPTIONS = -DXTENSOR_PYTHON_CMAKECONFIG_INSTALL_DIR="lib/cmake/xtensor-python"
+BUILD_OPTIONS = -DCMAKE_INSTALL_LIBDIR="lib"
 
 ifeq (,$(findstring nocheck,$(DEB_BUILD_PROFILES)))
 BUILD_OPTIONS += -DBUILD_TESTS=ON \

=== debian/tests/control ===
Test-Command: set -e
 ; cp -r test/* "$AUTOPKGTEST_TMP"
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; rm -rf build
 ; mkdir build && cd build
 ; echo "Testing with gcc and $py:"
 ; CC=gcc CXX=g++ cmake -DGTEST_SRC_DIR="/usr/src/googletest" -DPYTHON_EXECUTABLE="/usr/bin/$py" ..
 ; make -j $(nproc) xtest
 ; done
Depends: cmake,
         g++,
         googletest,
         python3-all-dev,
         python3-numpy,
         xtensor-python-dev
Restrictions: allow-stderr

Test-Command: set -e
 ; cp -r test/* "$AUTOPKGTEST_TMP"
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; rm -rf build
 ; mkdir build && cd build
 ; echo "Testing with clang and $py:"
 ; CC=clang CXX=clang++ cmake -DGTEST_SRC_DIR="/usr/src/googletest" -DPYTHON_EXECUTABLE="/usr/bin/$py" ..
 ; make -j $(nproc) xtest
 ; done
Depends: clang,
         cmake,
         googletest,
         python3-all-dev,
         python3-numpy,
         xtensor-python-dev
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/xtensor-python-$1\.tar\.gz/ \
https://github.com/QuantStack/xtensor-python/tags .*/v?(\d\S+)\.tar\.gz
